<%-- 
    Document   : play
    Created on : Jun 15, 2014, 1:06:25 PM
    Author     : German
--%>
<%@page import="edu.ehu.GB.MIF.nasdaqGame.*"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>

<%! 
private static final String to2decDouble(double d){ return String.format("%.2f",d);}
%>


<%
    int timeout = session.getMaxInactiveInterval();
    response.setHeader("Refresh", timeout + "; URL = login.jsp");
    
    //Adquisición del Nasdaq
    Nasdaq nasdaq=(Nasdaq)application.getAttribute("nasdaq");
    if (nasdaq==null) application.setAttribute("nasdaq",nasdaq=Nasdaq.getInstance());

    //Adquisición de la cartera  (no robusto, ojo al timeout)
    Cartera cartera;
    String saldo=request.getParameter("saldo");
    if (saldo!=null) session.setAttribute("cartera",cartera=new Cartera(Integer.parseInt(saldo)));
    else  cartera=(Cartera)session.getAttribute("cartera");
    
    
    //Gestión del instante temporal
    String tradeInstant=(String)session.getAttribute("tradeInstant");
    if (tradeInstant==null) tradeInstant=nasdaq.firstTradeInstant();
    if (request.getParameter("avance")!=null) 
        tradeInstant=Play.nextTradeInstant(tradeInstant);
    session.setAttribute("tradeInstant",tradeInstant);
    
    
    //Gestion de compra-ventas
    if (request.getParameter("compraventa")!=null)
        for (String s:nasdaq.getTickers()){
          String cantidad;  
          if ((cantidad=request.getParameter(s))!=null && cantidad!="") {
              int shares=Integer.parseInt(cantidad);
              if (shares>0) cartera.compra(s,shares,tradeInstant);
              if (shares<0) cartera.venta(s,-shares,tradeInstant);
          }
        }
    
    
    double valorCartera=cartera.valor(tradeInstant);
    
%>





<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="micss.css">
       <title>Entrenador del inversionista</title>
    </head>
    <body>
        <h1>Formulario de inversión</h1>
        <div class="banda">
            <form action="play.jsp">
                Fecha-instante: <%=tradeInstant%> 
                <input type="submit" name="avance" value="avance" />
            </form>
        </div>
        
        <div  class="center600">Su saldo es $<%=to2decDouble(cartera.getSaldo())%></div>
        
       
        <div>
            <form action="play.jsp">
                <table><theader><th>Ticker</th><th>Posición</th><th>Valor</th><th>Cotización</th><th>Compra(>0) / Venta(<0)</th></theader>
                    <% for (String s:Nasdaq.getTickers()) { %>
                    <tr>
                        <td class="right" ><%=s%></td>
                        <td class="estado"><%=cartera.posicion(s)%></td>
                        <td class="estado" >$<%=to2decDouble(cartera.valor(s,tradeInstant))%></td>
                        <td class="compraVenta">$<%=to2decDouble(nasdaq.cotizacion(s,tradeInstant))%></td>
                        <td class="compraVenta" style="text-align:center">
                            <input type="text" name="<%=s%>" size="8"/>
                        </td>
                    </tr>
                    <%}%>
                    <tr><td colspan="3"></td><td colspan="2" class="compraVenta" style="text-align:center">
                          <input type="submit" value="Ejecutar compraventa" name="compraventa" />
                        
                        </td></tr>
                </table>
                
            </form>
        </div>
                
        <div  class="center600">El valor total de la cartera es : $<%=to2decDouble(valorCartera)%></div>
    
               
        <div class="banda">Su capital es de $<%=to2decDouble(valorCartera+cartera.getSaldo())%></div>
        
    </body>
</html>
